<?php

namespace fk_\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfKCariMail ArrayType
 * @subpackage Arrays
 */
class ArrayOfKCariMail extends AbstractStructArrayBase
{
    /**
     * The KCariMail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \fk_\StructType\KCariMail[]
     */
    public $KCariMail;
    /**
     * Constructor method for ArrayOfKCariMail
     * @uses ArrayOfKCariMail::setKCariMail()
     * @param \fk_\StructType\KCariMail[] $kCariMail
     */
    public function __construct(array $kCariMail = array())
    {
        $this
            ->setKCariMail($kCariMail);
    }
    /**
     * Get KCariMail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \fk_\StructType\KCariMail[]|null
     */
    public function getKCariMail()
    {
        return isset($this->KCariMail) ? $this->KCariMail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setKCariMail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKCariMail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKCariMailForArrayConstraintsFromSetKCariMail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfKCariMailKCariMailItem) {
            // validation for constraint: itemType
            if (!$arrayOfKCariMailKCariMailItem instanceof \fk_\StructType\KCariMail) {
                $invalidValues[] = is_object($arrayOfKCariMailKCariMailItem) ? get_class($arrayOfKCariMailKCariMailItem) : sprintf('%s(%s)', gettype($arrayOfKCariMailKCariMailItem), var_export($arrayOfKCariMailKCariMailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The KCariMail property can only contain items of type \fk_\StructType\KCariMail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set KCariMail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \fk_\StructType\KCariMail[] $kCariMail
     * @return \fk_\ArrayType\ArrayOfKCariMail
     */
    public function setKCariMail(array $kCariMail = array())
    {
        // validation for constraint: array
        if ('' !== ($kCariMailArrayErrorMessage = self::validateKCariMailForArrayConstraintsFromSetKCariMail($kCariMail))) {
            throw new \InvalidArgumentException($kCariMailArrayErrorMessage, __LINE__);
        }
        if (is_null($kCariMail) || (is_array($kCariMail) && empty($kCariMail))) {
            unset($this->KCariMail);
        } else {
            $this->KCariMail = $kCariMail;
        }
        return $this;
    }
    /**
     * Add item to KCariMail value
     * @throws \InvalidArgumentException
     * @param \fk_\StructType\KCariMail $item
     * @return \fk_\ArrayType\ArrayOfKCariMail
     */
    public function addToKCariMail(\fk_\StructType\KCariMail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \fk_\StructType\KCariMail) {
            throw new \InvalidArgumentException(sprintf('The KCariMail property can only contain items of type \fk_\StructType\KCariMail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->KCariMail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \fk_\StructType\KCariMail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \fk_\StructType\KCariMail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \fk_\StructType\KCariMail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \fk_\StructType\KCariMail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \fk_\StructType\KCariMail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string KCariMail
     */
    public function getAttributeName()
    {
        return 'KCariMail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \fk_\ArrayType\ArrayOfKCariMail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
